#include <iostream>
#include <vector>
#include <queue>
using namespace std;

typedef long long ll;

const int DIM = 5000;

struct rect {
    ll x1, y1;
    ll x2, y2;
};

bool overlap(rect a, rect b) {
    //cout << a.x1 << a.y1 << a.x2 << a.y2<<endl;
    //cout << b.x1 << b.y1 << b.x2 << b.y2<<endl;
    if (a.y1 > b.y2 || b.y1 > a.y2)
        return false;
   // cout << "check1 " << endl;
    if (a.x1 > b.x2 || b.x1 > a.x2)
        return false;
   // cout << "check2" << endl;
    return true;
}


int n;
ll w, h;
rect a[DIM];
vector<vector<int>> v;
vector<int> u;

void fil(int ind) {
    for (int i = 0; i < n; i++) {
        if (overlap(a[ind], a[i]) && i != ind) {
            
            v[ind].push_back(i);
        }
    }
}

void filAll() {
    for (int i = 0; i < n; i++) {
        fil(i);
    }
}

bool check(vector<int> x) {
    int x0 = 0, y0 = 0, xN = 0, yN = 0;
    for (auto i : x) {
        if (a[i].x1 == 0) x0 = 1;
        if (a[i].y1 == 0) y0 = 1;
        if (a[i].x2 == w) xN = 1;
        if (a[i].y2 == h) yN = 1;
        //cout << i << " ";
    }
    //cout << " - " << x0 << y0 << xN << yN << endl;
    if (x0 == 1 && y0 == 1) return true;
    if (xN == 1 && yN == 1) return true;
    if (x0 == 1 && xN == 1) return true;
    if (y0 == 1 && yN == 1) return true;
    return false;
}

bool cringeBFS(int st) {
    queue<int> q;
    vector<int> x;
    q.push(st);
    if (u[st]) return false;
    while (!q.empty()) {
        int vv = q.front();
        x.push_back(vv);
        q.pop();
        if (u[vv]) continue;
        u[vv] = 1;
        for (auto to : v[vv]) q.push(to);
    }
    return check(x);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> w >> h >> n;
    u.resize(n);
    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x1 >> a[i].y1 >> a[i].x2 >> a[i].y2;
        u[i] = 0;
    }
    filAll();
    /*for (int i = 0; i < n; i++) {
        for (auto j : v[i]) cout << j << " ";
        cout << endl;
    }
    return 0;*/
    for (int i = 0; i < n; i++) {
        if (cringeBFS(i)) {
            cout << "NO";
            return 0;
        }
    }
    cout << "YES";
}
