using System;
using System.Linq;
using System.Collections.Generic;

class Solution {
  public static void Main(string[] args) {
    int[] firstLine = Console.ReadLine().Split(" ").Select(n => int.Parse(n)).ToArray();
    int n = firstLine[0];
    Vector2Int dog = new (firstLine[1], firstLine[2]);
    Vector2Int bee = new (firstLine[3], firstLine[4]);
    

    List<Vector2Int> spheres = new();

    for(int i = 0; i < n; i++)
    {
        int[] s = Console.ReadLine().Split(" ").Select(n => int.Parse(n)).ToArray();
        spheres.Add(new (s[0], s[1]));
    }

    for(int i = 0; i < n; i++)
    {
        var sphere = spheres[i];
        if(IsInsideSphere(dog, sphere) == IsInsideSphere(bee, sphere)) continue;

        Console.WriteLine("NO");
        Console.WriteLine(i + 1);
        return;
    }

    Console.WriteLine("YES");
  }

  public static bool IsInsideSphere(Vector2Int entity, Vector2Int sphere)
  {
    Vector2Int sphereCoordinates = new (sphere.x, 0);
    var dx = Math.Abs(entity.x - sphereCoordinates.x);
    var dy = entity.y;
    double sqrDistance = dx*dx + dy*dy;

    //Console.WriteLine($"{entity.x}x {entity.y}y {sphere.x}x {sphere.y}r");
    //Console.WriteLine(sqrDistance <= sphere.y * sphere.y);
    return sqrDistance <= sphere.y * sphere.y;
  }

  public struct Vector2Int
  {
    public int x;
    public int y;

    public Vector2Int(int x, int y)
    {
        this.x = x;
        this.y = y;
    }
  }
}
