using System;
using System.Linq;
using System.Collections.Generic;

class Solution {

  public class Group
  {
    public List<int> towns = new();

    public void Merge(Group g)
    {
      var l = g.towns.Where(n => !towns.Contains(n));
      towns.AddRange(l);
    }

    public bool HasSameTowns(Group g)
    {
      return g.towns.Any(n => towns.Contains(n));
    }

    public Group(){}
  }

  public static void Main(string[] args) {
    int n = int.Parse(Console.ReadLine());
    
    List<Group> groups = new();
    for(int i = 0; i < n; i++) groups.Add(new());

    for(int i = 0; i < n; i++)
    {
      var r = i + 1;
      var r1 = r * 2;
      var r2 = r1 > n ? r1 - n : r1;

      groups[i].towns.Add(r);
      groups[i].towns.Add(r2);
    }
    
    for(int i = 0; i < groups.Count; i++)
    {
      var currentGroup = groups[i];
      var appendGroup = groups.Find(g => currentGroup.HasSameTowns(g) && g != currentGroup);

      if(appendGroup is null && i != groups.Count - 1) 
      {
        Console.WriteLine("NO");
        var num1 = groups.First().towns.First();
        var num2 = groups.Find(g => !currentGroup.HasSameTowns(g)).towns.First();

        Console.WriteLine($"{num1} {num2}");
        return;
      }

      if(appendGroup is null) continue;

      groups.Remove(appendGroup);
      currentGroup.Merge(appendGroup);
      i--;
    }
    
    var success = groups.Count == 1;
    if(success)
    {
      Console.WriteLine("YES");
      return;
    }
  }
}
