#include <bits/stdc++.h>
using namespace std;

struct rect{
	public:
		int x1;
		int y1;
		int x2;
		int y2;
		rect(){
			x1 = 0;
			x2 = 0;
			y1 = 0;
			y2 = 0;
		}
		rect(int X1, int Y1, int X2, int Y2){
			x1 = X1;
			x2 = X2;
			y1 = Y1;
			y2 = Y2;
		}
};

bool inside(rect a, int x, int y){
	return x >= a.x1 && x <= a.x2 && y >= a.y1 && y <= a.y2;
}

bool intersect(rect a, rect b){
	return inside(a, b.x1, b.y1) ||
		   inside(a, b.x1, b.y2) ||
		   inside(a, b.x2, b.y1) ||
		   inside(a, b.x2, b.y2) ||
		   inside(b, a.x1, a.y1) ||
		   inside(b, a.x2, a.y1) ||
		   inside(b, a.x1, a.y2) ||
		   inside(b, a.x2, a.y2);
}

int m, n, k;
bool up[5000]={0}, down[5000]={0}, _left[5000]={0}, _right[5000]={0};
vector<rect> r;

bool dfs(bool used[5000], int v, bool u, bool d, bool l, bool R){
	if((up[v]&&u)||(down[v]&&d)||(_right[v]&&R)||(_left[v]&&l)){
		return true;
	}
	used[v] = 1;
	bool ans = 0;
	for (int i = 0; i < k;i++){
		if(i!=v){
			if(!used[i]){
				if(intersect(r[v], r[i])){
					ans = ans || dfs(used, i, u, d, l, R);
				}
			}
		}
	}
	return ans;
}

void solve(){
	cin >> n >> m >> k;
	for (int i = 0; i < k;i++){
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		r.push_back(rect(x1, y1, x2, y2));
		if(x1==0)
			up[i] = 1;
		if(y1==0)
			_left[i] = 1;
		if(x2==n)
			down[i] = 1;
		if(y2==m)
			_right[i] = 1;
		
		if((up[i]&&down[i]) || (_left[i]&&_right[i]) || (up[i]&&_left[i]) || (down[i]&&_right[i])){
			cout << "NO\n";
			return;
		}
	}

	for (int i = 0; i < k;i++){
		if(down[i]){
			bool used[5000]={0};
			if(dfs(used, i, 1, 0, 0, 1)){
				cout << "NO\n";
				return;
			}
		}
		if(up[i]){
			bool used[5000]={0};
			if(dfs(used, i, 0, 1, 1, 0)){
				cout << "NO\n";
				return;
			}
		}
		if(_left[i]){
			bool used[5000]={0};
			if(dfs(used, i, 1, 0, 0, 1)){
				cout << "NO\n";
				return;
			}
		}
		if(_right[i]){
			bool used[5000]={0};
			if(dfs(used, i, 0, 1, 1, 0)){
				cout << "NO\n";
				return;
			}
		}
	}
	cout << "YES\n";
}

int main() {
	ios::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);
	int t = 1;
	// cin>>t;
	while(t--){
		solve();
	}
}