#include <bits/stdc++.h>
#pragma optimization_level 3 
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math,O3") 
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx")
using namespace std;

struct rect{
	public:
		int x1;
		int y1;
		int x2;
		int y2;
		rect(){
			x1 = 0;
			x2 = 0;
			y1 = 0;
			y2 = 0;
		}
		rect(int X1, int Y1, int X2, int Y2){
			x1 = X1;
			x2 = X2;
			y1 = Y1;
			y2 = Y2;
		}
};


bool intersect(rect a, rect b){
	if(a.x2<b.x1 || a.x1>b.x2)
		return false;
	if(a.y1>b.y2 || a.y2<b.y1){
		return false;
	}
	return true;
}

int m, n, k;
bool up[5000]={0}, down[5000]={0}, _left[5000]={0}, _right[5000]={0};
vector<rect> r;
vector<vector<int> > g;

bool dfs(bool used[5000], int v, bool u, bool d, bool l, bool R){
	if((up[v]&&u)||(down[v]&&d)||(_right[v]&&R)||(_left[v]&&l)){
		return true;
	}
	used[v] = 1;
	bool ans = 0;
	for(int U:g[v]){
		if(!used[U]){
			ans = ans || dfs(used, U, u, d, l, R);
		}
	}
	return ans;
}

void solve(){
	cin >> n >> m >> k;
	g.resize(k);
	for (int i = 0; i < k;i++){
		int x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		r.push_back(rect(x1, y1, x2, y2));
		for (int j = 0; j < i;j++){
			if(intersect(r[i], r[j])){
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
		if (x1 == 0)
			up[i] = 1;
		if(y1==0)
			_left[i] = 1;
		if(x2==n)
			down[i] = 1;
		if(y2==m)
			_right[i] = 1;
		
		if((up[i]&&down[i]) || (_left[i]&&_right[i]) || (up[i]&&_left[i]) || (down[i]&&_right[i])){
			cout << "NO\n";
			return;
		}
	}

	for (int i = 0; i < k;i++){
		if(up[i]){
			bool used[5000]={0};
			if(dfs(used, i, 0, 1, 1, 0)){
				cout << "NO\n";
				return;
			}
		}
		if(_right[i]){
			bool used[5000]={0};
			if(dfs(used, i, 0, 1, 1, 0)){
				cout << "NO\n";
				return;
			}
		}
		if(_left[i]){
			bool used[5000]={0};
			if(dfs(used, i, 1, 0, 0, 1)){
				cout << "NO\n";
				return;
			}
		}
		if(down[i]){
			bool used[5000]={0};
			if(dfs(used, i, 1, 0, 0, 1)){
				cout << "NO\n";
				return;
			}
		}
	}
	cout << "YES\n";
 
}

int main() {
	ios::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);
	int t = 1;
	// cin>>t;
	while(t--){
		solve();
	}
}