#include <bits/stdc++.h>

using namespace std;

struct Node
{
    int x, y, dist;
};

int row[] = { -1, 0, 0, 1 };
int col[] = { 0, -1, 1, 0 };

bool isMyFuction(int* mat[], bool* arr[], int n, int m, int row, int col)
{
    return (row >= 0 && row < n) && (col >= 0 && col < m)
        && mat[row][col] && !arr[row][col];
}

int sorten(int* mat[], int nn, int mm, pair<int, int>& src, pair<int, int>& dest)
{
    if (nn == 0 || mat[src.first][src.second] == 0 ||
        mat[dest.first][dest.second] == 0) {
        return -1;
    }

    int N = nn;
    int M = mm;

    bool** arr = (bool**)malloc(N * sizeof(bool*));
    for (int i = 0; i < N; ++i)
    {
        arr[i] = (bool*)malloc(M * sizeof(bool));
    }

    for (int i = 0; i < N; ++i)
    {
        for (int j = 0; j < M; ++j)
        {
            arr[i][j] = false;
        }
    }

    queue<Node> q;

    int i = src.first;
    int j = src.second;

    arr[i][j] = true;
    q.push({ i, j, 0 });

    int min_dist = INT_MAX;

    while (!q.empty())
    {
        Node node = q.front();
        q.pop();

        int i = node.x, j = node.y, dist = node.dist;

        if (i == dest.first && j == dest.second)
        {
            min_dist = dist;
            break;
        }


        for (int k = 0; k < 4; k++)
        {
            if (isMyFuction(mat, arr, N, M, i + row[k], j + col[k]))
            {
                arr[i + row[k]][j + col[k]] = true;
                q.push({ i + row[k], j + col[k], dist + 1 });
            }
        }
    }

    if (min_dist != INT_MAX) {
        return min_dist;
    }

    return -1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
  
    int n = 2, m = 4, k = 1;
    cin >> n >> m >> k;
    int** mat = (int**)malloc(n * sizeof(int*));
    for (int i = 0; i < n; ++i)
    {
        mat[i] = (int*)malloc(m * sizeof(int));
    }


    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            mat[i][j] = 1;
        }
    }
    int x1, y1, x2, y2;
    for (int i = 0; i < k; ++i)
    {
        cin >> x1 >> y1 >> x2 >> y2;
        for (int x = x1; x < x2; x++)
        {
            for (int y = y1; y < y2; ++y)
            {
                mat[x][y] = 0;
            }
        }
    }
#if 0
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            cout << mat[i][j] << " ";
        }
        cout << endl;
    }
#endif

    pair<int, int> src = make_pair(0, 0);
    pair<int, int> dest = make_pair(n - 1, m - 1);

    int min_dist = sorten(mat, n, m, src, dest);
    if (min_dist != -1)
    {
        cout << "YES" << endl;
    }
    else {
        cout << "NO" << endl;
    }

    return 0;
}
