#include <iostream>
#include <set>
#include<math.h>
#include <vector>
using namespace std;


struct Point {
	int x, y;
	Point(int x, int y) {
		this->x = x;
		this->y = y;
	}
	Point() {
		this->x = 0;
		this->y = 0;
	}
};

struct Circle {
	int pos, radius;
	Circle(int pos, int radius) {
		this->pos = pos;
		this->radius = radius;
	}
	Circle() {
		this->pos = 0;
		this->radius = 0;
	}
	
	set<pair<int, int> > inside;
	void Find(int pos, int radius) {
		for (int x = 0; x <= radius; ++x) {
			for (int y = 0; y <= radius; ++y) {
				if ((x*x + y*y) <= (radius * radius)) {
					inside.insert(make_pair(x + pos, y));
				}
				if (((x - 2 * pos) * (x - 2 * pos) + y * y) <= (radius * radius)) {
					inside.insert(make_pair(x - pos, y));
				}
			}
		}
	}
	
};

int main() {
	Point dog, bee;
	int n;
	cin >> n >> dog.x >> dog.y >> bee.x >> bee.y;

	
	vector<Circle> circles;

	for (int i = 0; i < n; ++i) {
		int pos,radius;
		cin >> pos >> radius;
		circles.push_back(Circle(pos, radius));
		circles[i].Find(circles[i].pos, circles[i].radius);
	}
	
	for (int i = 0; i < n; ++i) {
		if (circles[i].inside.find(make_pair(dog.x, dog.y)) != circles[i].inside.end() && 
			circles[i].inside.find(make_pair(bee.x, bee.y)) == circles[i].inside.end()) {
			cout << "NO" << endl << i + 1;
			return 0;
		}
		if (circles[i].inside.find(make_pair(dog.x, dog.y)) == circles[i].inside.end() &&
			circles[i].inside.find(make_pair(bee.x, bee.y)) != circles[i].inside.end()) {
			cout << "NO" << endl << i + 1;
			return 0;
		}
	}
	cout << "YES";
	return 0;
}