process.stdin.on('data', function (data) {
	let lines = (""+data)
		.split('\n').map(e => {
			return e.split(' ')
				.map(i => parseInt(i, 10));
		});
    lines.splice(-1, 1);

    const [n, dogX, dogY, hiveX, hiveY] = lines.splice(0, 1)[0];
	lines = lines.map(e => { return { x: e[0], r: e[1] } });

	function intersectionCheck(domeX, domeR) {
		const vec1 = { x: hiveX - dogX, y: hiveY - dogY };
		const vec2 = { x: dogX - domeX, y: dogY };
		const scal1 = -2*(vec1.x * vec2.x + vec1.y * vec2.y);
		const scal2 = 2*(vec1.x**2 + vec1.y**2);
		const dome = Math.sqrt(scal1**2 - 2*scal2*( vec2.x**2 + vec2.y**2 - domeR**2));
		if (!dome)
			return;

		const d1 = (scal1 - dome) / scal2;
		const d2 = (scal1 + dome) / scal2;
		let intersections = [];
		if (d1 <= 1 && d1 >= 0)
			intersections.push({
				x: dogX + vec1.x * d1,
				y: dogY + vec1.y * d1
			});
		if (d2 <= 1 && d2 >= 0)
			intersections.push({
				x: dogX + vec1.x * d2,
				y: dogY + vec1.y * d2
			});
		return intersections.length>0 ? intersections : undefined;
	}

	const dome = lines.reduce((acc, e, i) => {
		const intersections = intersectionCheck(e.x, e.r);
		if (!intersections)
			return acc;

		const d1 = (dogX - intersections[0].x)**2 + (dogY - intersections[0].y)**2;
		const d2 = intersections[1] 
			? (dogX - intersections[1].x)**2 + (dogY - intersections[1].y)**2
			: d1+1;
		const d = Math.min(d1, d2);
		if (d < acc.d)
			return { d: d, i: i };
		return acc;
	}, { i: -1, d: Infinity });

	dome.i === -1
		? console.log('YES')
		: console.log('NO\n'+(dome.i+1));
});
