# Helper function to check if a cell is valid
def is_valid(x, y, n, m):
    return x >= 0 and x < n and y >= 0 and y < m

# Helper function to check if a cell is blocked
def is_blocked(x, y, blocked):
    return (x, y) in blocked

# Function to check if it's possible to go from one corner to another
def can_go(n, m, k, rectangles):
    blocked = set()
    # Mark blocked cells
    for i in range(k):
        x1, y1, x2, y2 = rectangles[i]
        for x in range(x1, x2 + 1):
            for y in range(y1, y2 + 1):
                blocked.add((x, y))
    # Perform BFS
    queue = [(0, 0)]
    visited = set()
    while queue:
        x, y = queue.pop(0)
        visited.add((x, y))
        # Check if current cell is the destination
        if x == n and y == m:
            return 'YES'
        # Check all possible moves
        for dx, dy in [(0.5, 0), (0, 0.5), (-0.5, 0), (0, -0.5)]:
            new_x, new_y = x + dx, y + dy
            if is_valid(new_x, new_y, n, m) and not is_blocked(new_x, new_y, blocked) and (new_x, new_y) not in visited:
                queue.append((new_x, new_y))
    return 'NO'

n, m, k = map(int, input().split())
rectangles = []
for _ in range(k):
    x1, y1, x2, y2 = map(int, input().split())
    rectangles.append((x1, y1, x2, y2))
result = can_go(n, m, k, rectangles)
print(result) # Output: NO