#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
using namespace std;
typedef long long int;
struct SegTree {
    int n;
    vector < pair < int, int >> t;
    SegTree(int nn) {
        n = 1 << ((int)ceil(log2(nn)));
        t.resize(n << 1, {1e9 + 1, 1});
    }
    void build() {
        for (int i = n - 1; i > 0; --i)
            t[i] = min(t[i << 1], t[i << 1 | 1]);
    }
    pair < int, int > res(int l, int r) {
		++r;
		pair < int, int > ans = {1e9 + 1, 1};
		for(l += n, r += n; l < r; l >>= 1, r >>= 1) {
			if(l & 1)
				ans = min(ans, t[l++]);
			if(r & 1)
				ans = min(ans, t[--r]);
		}
		return ans;
   	}
	ll query(int l, int r) {
		int i = res(l, r).second;
		auto p1 = res(l, i - 1), p2 = res(i + 1, r);
		int j = (p1 < p2 ? p1.second : p2.second);
		return (ll)(r - l + 1) * (t[n + i].first + t[n + j].first);
	}
};
signed main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	srand(time(0));
	int n;
	cin >> n;
	SegTree t(n);
	for (int i = 0; i < n; ++i)
		cin >> t.t[t.n + i].first, t.t[t.n + i].second = i;
	t.build();
	int mx = 6e7 / log2(n);
	ll ans = t.query(0, n - 1);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j + i < n && mx; ++j, --mx) {
			ans = max(ans, t.query(i, i + j);
		}
	}	
	cout << ans;
	return 0;
}
