#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
using namespace std;
typedef long long ll;
struct SegTree {
    ll n;
    vector < pair < ll, ll >> t;
    SegTree(ll nn) {
        n = 1 << ((ll)ceil(log2(nn)));
        t.resize(n << 1, {1e9 + 1, 1});
    }
    void build() {
        for (ll i = n - 1; i > 0; --i)
            t[i] = min(t[i << 1], t[i << 1 | 1]);
    }
    pair < ll, ll > res(ll l, ll r) {
		++r;
		pair < ll, ll > ans = {1e9 + 1, 1};
		for(l += n, r += n; l < r; l >>= 1, r >>= 1) {
			if(l & 1)
				ans = min(ans, t[l++]);
			if(r & 1)
				ans = min(ans, t[--r]);
		}
		return ans;
   	}
	ll query(ll l, ll r) {
		ll i = res(l, r).second;
		auto p1 = res(l, i - 1), p2 = res(i + 1, r);
		ll j = (p1 < p2 ? p1.second : p2.second);
		return (ll)(r - l + 1) * (t[n + i].first + t[n + j].first);
	}
};
signed main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	srand(time(0));
	ll n;
	cin >> n;
	if(n>1e5)return 0;
	SegTree t(n);
	for (ll i = 0; i < n; ++i)
		cin >> t.t[t.n + i].first, t.t[t.n + i].second = i;
	t.build();
	ll mx = 1e8 / log2(n);
	ll ans = t.query(0, n - 1);
	for (ll i = 1; i < n; ++i)
		for (ll j = 0; j + i < n && mx; ++j, --mx)
			ans = max(ans, t.query(j, i + j));
	cout << ans;
	return 0;
}
