def is_possible(n, m, k, rectangles):
  visited = [[False]*m for _ in range(n)]
  def is_valid(x, y):
    if x < 0 or y < 0 or x >= n or y >= m:
      return False
    for x1, y1, x2, y2 in rectangles:
      if x1 <= x < x2 and y1 <= y < y2:
        return False
    return True
  def dfs(x, y):
    visited[x][y] = True
    for i, j in [(x-1, y), (x+1, y), (x, y-1), (x, y+1)]:
      if is_valid(i, j) and not visited[i][j]:
        dfs(i, j)
  dfs(0, 0)
  return visited[n-1][m-1]
def main():
  n, m, k = map(int, input().split())
  rectangles = []
  for _ in range(k):
    x1, y1, x2, y2 = map(int, input().split())
    rectangles.append((x1, y1, x2, y2))
  if is_possible(n, m, k, rectangles):
    print("YES")
  else:
    print("NO")
if __name__ == '__main__':
  main()