#include <bits/stdc++.h>

const int N = 1e6 + 10, K = 5000;

using namespace std;
typedef long long ll;
typedef pair<int, int> pi;

int dsu[K];
int type[K];

int find(int v){
    if(dsu[v] == v) return v;
    return dsu[v] = find(dsu[v]);
}

void merge(int u, int v){
    u = find(u);
    v = find(v);
    if(u == v) return;
    dsu[v] = u;
    type[v] |= type[u];
    if(type[v] == 3){
        cout << "NO\n";
        exit(0);
    }
}

struct p{
    int x, y;
};

struct sq{
    p tl, br;
};

struct ln{
    bool up;
    p tl;
    int len;
    int i = 0;
};

bool isIntersecting(ln v, ln u){
    if(v.up == u.up)
        return 0;
    if(v.tl.x == u.tl.x && v.tl.y == u.tl.y)
        return 1;
    if(v.tl.x < u.tl.x || (v.tl.x == u.tl.x && v.tl.y > u.tl.y))
        swap(v, u);
    if(v.tl.x > u.tl.x && v.tl.y > u.tl.x)
        return 0;
    if(!v.up)
        return 0;
    if(v.tl.x == u.tl.x && v.tl.y == u.tl.y)
        return 1;
    v.tl.y += v.len;
    u.tl.x += u.len;
    //if(v.tl.x <= u.tl.x && v.tl.y <= u.tl.x && v.i + u.i == 1) cout << "1 3 connected: v: {" << v.tl.x << ", " << v.tl.y - v.len << "}, u: {" << u.tl.x - u.len << ", " << u.tl.y << "}\n";
    if(v.tl.x <= u.tl.x && v.tl.y >= u.tl.y)
        return 1;
    return 0;
}

vector<ln> toLn(sq a, int i = 0){
    vector<ln> f;
    f.push_back({0, a.tl, abs(a.tl.x - a.br.x), i});
    f.push_back({1, a.tl, abs(a.tl.y - a.br.y), i});
    f.push_back({1, {a.br.x, a.tl.y}, abs(a.tl.y - a.br.y), i});
    f.push_back({0, {a.tl.x, a.br.y}, abs(a.tl.x - a.br.x), i});
    //for(auto &c: f) c.up = !c.up;
    return f;
}

bool connected(sq a, sq b, int ai = 0, int bi = 0){
    vector<ln> al = toLn(a, ai), bl = toLn(b, bi);
    for(auto c: al)
        for(auto c2: bl)
            if(isIntersecting(c, c2))
                return 1;
    return 0;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    sq a[K];
    vector<pair<int, pair<bool, int>>> t; //y, i
    for(int i = 0; i < k; ++i){
        dsu[i] = i;
        type[i] = 0;
        cin >> a[i].tl.x >> a[i].tl.y >> a[i].br.x >> a[i].br.y;
        if(a[i].tl.x == 0 || a[i].br.y == m)
            type[i] |= 1;
        if(a[i].tl.y == 0 || a[i].br.x == n)
            type[i] |= 2;
        if(type[i] == 3){
            cout << "NO\n";
            return 0;
        }
        t.push_back({a[i].tl.y, {0, i}});
        t.push_back({a[i].br.y, {1, i}});
    }
    sort(t.begin(), t.end());
    for(auto c: t)
        cout << c.first << ' ' << c.second.first << '\n';
    if(k > 3){
        for(int i = 0; i < k; ++i)
            for(int j = i + 1; j < k; ++j)
                if(connected(a[i], a[j], i, j)){
                    //cout << "connected: " << i + 1 << ' ' << j + 1 << '\n';
                    merge(i, j);
                }
        cout << "YES\n";
        return 0;
    }
    set<pair<int, int>> oc;
    for(auto c: t){
        auto [cl, i] = c.second;
        if(cl){
            oc.erase({a[i].tl.x, i});
            oc.erase({a[i].br.x, i});
            continue;
        }
        for(auto c: oc)
            if(a[i].tl.x <= c.first && c.first <= a[i].br.x)
                merge(i, c.second);
        oc.insert({a[i].tl.x, i});
        oc.insert({a[i].br.x, i});
    }
    cout << "YES\n";
}
