#include <iostream>
#include <stack>
#include <set>
#include <vector>
#include <utility>
using namespace std;

void check_connected(vector<pair<int,int>> graph) {
    set<int> visited;
    stack<int> stack;
    stack.push(graph[0].first);

    while (!stack.empty()) {
        int current = stack.top();
        stack.pop();
        visited.insert(current);

        for (auto edge : graph) {
            if (current == edge.first || current == edge.second) {
                if (visited.find(edge.first) == visited.end())
                    stack.push(edge.first);
                if (visited.find(edge.second) == visited.end())
                    stack.push(edge.second);
            }
        }
    }

    if (visited.size() == graph.size())
        cout << "YES" << endl;
    else
        cout << "NO" << endl;
        
}

vector<pair<int,int>> create_graph(int n) {
    vector<pair<int,int>> graph;
    for (int i = 1; i <= n; i++) {
        if (i + i > n)
            graph.push_back({i, i + i - n});
        else
            graph.push_back({i, i + i});
    }

    return graph;
}

int main() {
    int n;
    cin >> n;
    vector<pair<int,int>> graph = create_graph(n);


    check_connected(graph);
    cout << 1 << " " << n << endl;
    return 0;
}
